int 
read_region(FILE *pin)
{
  extern int NN;
  extern int color[], pospt[], negpt[], clabelpt[];
  extern int point[8][N];
  extern int KK[N][N];

  char checkstr[256];
  int i, ip, in, dir;

  fscanf(pin,"%d",&NN);
  if ( (NN&1) == 1 ) return(-2);
  Nh = NN/2;

  for ( i = NN ; i < N ; i++ )
  {
    color[i] = 0;
    clabelpt[i] = -1;
    for ( dir = 0 ; dir < 8 ; dir++ ) point[dir][i] = -1;
  }

  ip = 0; in = 0;
  fscanf(pin,"%s",checkstr);
  for ( i = 0 ; i < NN ; i++ )
  {
    if ( checkstr[i] == '+' )
    { color[i] = 1; clabelpt[i] = ip; pospt[ip] = i; ip++; }
    else if ( checkstr[i] == '-' )
    { color[i] = -1; clabelpt[i] = in; negpt[in] = i; in++; }
    else { return(-4); }
  }
  if ( ( ip != Nh ) || ( in != Nh ) ) return(-5);
  for ( i = Nh ; i < N ; i++ ) { pospt[i] = -1; negpt[i] = -1; }

  fscanf(pin,"%s",checkstr);
  if ( checkstr[0] != 'a' ) return(-8);
  for ( i = 0 ; i < N ; i++ ) fscanf(pin,"%d",point[0]+i);
  fscanf(pin,"%s",checkstr);
  if ( checkstr[0] != 'b' ) return(-9);
  for ( i = 0 ; i < N ; i++ ) fscanf(pin,"%d",point[1]+i);
  fscanf(pin,"%s",checkstr);
  if ( checkstr[0] != 'c' ) return(-10);
  for ( i = 0 ; i < N ; i++ ) fscanf(pin,"%d",point[2]+i);
  fscanf(pin,"%s",checkstr);
  if ( checkstr[0] != 'd' ) return(-11);
  for ( i = 0 ; i < N ; i++ ) fscanf(pin,"%d",point[3]+i);
  fscanf(pin,"%s",checkstr);
  if ( checkstr[0] != 'e' ) return(-12);
  for ( i = 0 ; i < N ; i++ ) fscanf(pin,"%d",point[4]+i);
  fscanf(pin,"%s",checkstr);
  if ( checkstr[0] != 'f' ) return(-13);
  for ( i = 0 ; i < N ; i++ ) fscanf(pin,"%d",point[5]+i);
  fscanf(pin,"%s",checkstr);
  if ( checkstr[0] != 'g' ) return(-14);
  for ( i = 0 ; i < N ; i++ ) fscanf(pin,"%d",point[6]+i);
  fscanf(pin,"%s",checkstr);
  if ( checkstr[0] != 'h' ) return(-15);
  for ( i = 0 ; i < N ; i++ ) fscanf(pin,"%d",point[7]+i);

  fscanf(pin,"%s",checkstr);
  if ( checkstr[0] != 'K' ) return(-50);

  for ( ip = 0 ; ip < Nh ; ip++ )
  for ( in = 0 ; in < Nh ; in++ )
  {
    fscanf(pin,"%d",KK[ip]+in);
  }


  fscanf(pin,"%s",checkstr);

  if ( ( checkstr[0] != 'E' ) || ( checkstr[1] != 'N' ) || ( checkstr[2] != 'D' ) )
  { return(-1); }

  return(NN);
}
